/***************************************
This program was produced by the
CodeWizardAVR V1.0.0.8v Evaluation
Automatic Program Generator
 Copyright 1998-2000
Pavel Haiduc, HP InfoTech S.R.L.
http://infotech.ir.ro
e-mail:dhptechn@ir.ro , hpinfotech@mail.com

Project : uart
Version : 
Date    : 10/21/2000
Author  : 
Company : 
Comments: 


Chip type        : AT90S4414
Clock frequency  : 4.000000 MHz
Memory model     : Tiny
Internal RAM size: 256
External RAM size: 0
Data Stack size  : 64
***************************************/

#include <90s8515.h>

// Standard Input/Output functions
#include <stdio.h>

// delays
#include <delay.h>

#define CLK_PULSE 5
#define PI 3.14159265359       
#define CAP1 1e-9
#define RPAD 100e3

// Declare your global variables here 
//unsigned char loadbit; 
//int freq; 

unsigned char convert(int freq) {
	//convert freq into load bits
	//R = 1/(2pifC)               
	//then loadbit = (R/1M)*128  
	unsigned char loadbit;
// 1M only
 	loadbit = (unsigned char) (128/(2*PI*freq*CAP1*1e6)); 
//1M with pad of 100k
  //	resis =  (1/(2*PI*freq*CAP1);
  //	resis = (resis*RPAD)/(RPAD-resis);
  //	loadbit = (resis*128/1e6); 
 	printf("loadbit = %d \n",loadbit);
 	return loadbit;
}             

void set_VR(unsigned char loadbit)
{
	int i;     
	unsigned char tempout;
	printf("inside set_VR \n"); 
	printf("loadbit = %d \n",loadbit);
		
//bring cs high and clk low
	PORTB = 0x02;
	delay_ms(CLK_PULSE);
//bring down clock
	//PORTB= 0x02;
	//delay_ms(CLK_PULSE);
//bring cs low
	PORTB = 0x00;       
	delay_ms(CLK_PULSE);
	for (i= 0; i<7; i++){
	//set up the data 
		loadbit = (loadbit<<1);
		tempout = ((loadbit & 0x80)>>5);
		PORTB = (tempout);
		delay_ms(CLK_PULSE);
	//rise the clock
		PORTB = (tempout | 0x01);
		delay_ms(CLK_PULSE);
	//drop the clock
		PORTB = (0x00);
		delay_ms(CLK_PULSE);   
	}
//set CS high
	PORTB = 0x02;
	delay_ms(CLK_PULSE);
}   
void main(void)
{
// Declare your local variables here
   unsigned int myint;
// the LED on  output 0 will be on

// Input/Output Ports initialization
// Port A
DDRA=0x00;
PORTA=0x00;

// Port B 
DDRB=0xff;
PORTB=0x02; //setup clock low and CS low

// Port C
DDRC=0x00;
PORTC=0x00;

// Port D
DDRD=0x00;
PORTD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Output Compare
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Output Compare
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// UART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// UART Receiver: On
// UART Transmitter: On
UCR=0x18;
// UART Baud rate: 9600
UBRR=0x19;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;

                       

while (1)
{
      // test loop
	printf("Inside Main\n");      
 	printf("Enter in a number:\n");      
  	scanf("%d",&myint);
   	printf("my value is: %d \n",myint);
    //set_VR(convert(myint)); 
    set_VR((unsigned char) myint); 
 }

}
