VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "Mscomm32.ocx"
Begin VB.Form Form1 
   Caption         =   "   Active Filter Controller"
   ClientHeight    =   3480
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7260
   Icon            =   "vb_test1.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3480
   ScaleWidth      =   7260
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton resync 
      Caption         =   "Resync "
      CausesValidation=   0   'False
      Height          =   495
      Left            =   5280
      TabIndex        =   10
      Top             =   1320
      Width           =   1815
   End
   Begin VB.Frame Frame2 
      Caption         =   "Settings"
      Height          =   1095
      Left            =   120
      TabIndex        =   6
      Top             =   2040
      Width           =   4815
      Begin VB.Label Label_notsynched 
         Caption         =   "not_syched"
         ForeColor       =   &H000000FF&
         Height          =   255
         Left            =   2880
         TabIndex        =   11
         Top             =   720
         Width           =   1815
      End
      Begin VB.Label label_sync 
         Caption         =   "Sync Status:"
         Height          =   255
         Left            =   2880
         TabIndex        =   9
         Top             =   480
         Width           =   1695
      End
      Begin VB.Label label_comport 
         Caption         =   "COM port:"
         Height          =   255
         Left            =   2880
         TabIndex        =   8
         Top             =   240
         Width           =   1575
      End
      Begin VB.Label Label_Freqout 
         Caption         =   "Current Frequency:"
         Height          =   255
         Left            =   120
         TabIndex        =   7
         Top             =   240
         Width           =   2535
      End
   End
   Begin VB.CommandButton ConfigCom 
      Caption         =   "Configure COM port"
      Height          =   495
      Left            =   5280
      TabIndex        =   5
      Top             =   720
      Width           =   1815
   End
   Begin VB.CommandButton calibrate 
      Caption         =   "Calibrate Frequencies"
      Height          =   495
      Left            =   5280
      TabIndex        =   3
      Top             =   120
      Width           =   1815
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   2640
      Top             =   1080
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.CommandButton set_freq 
      Caption         =   "Set Frequency"
      Height          =   375
      Left            =   2520
      TabIndex        =   2
      Top             =   600
      Width           =   1695
   End
   Begin VB.ListBox List1 
      Height          =   1035
      ItemData        =   "vb_test1.frx":030A
      Left            =   120
      List            =   "vb_test1.frx":030C
      TabIndex        =   1
      Top             =   480
      Width           =   2175
   End
   Begin VB.CommandButton Exit 
      Caption         =   "Exit"
      Height          =   495
      Left            =   5280
      TabIndex        =   0
      Top             =   2400
      Width           =   1815
   End
   Begin VB.Frame Frame1 
      Caption         =   "Frequency Selector"
      Height          =   1695
      Left            =   0
      TabIndex        =   4
      Top             =   120
      Width           =   4575
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public resistance As Double
Private comport As Integer
Private loadfreq As Integer


Private Sub Form_Load()
'On Error Resume Next


'Setup comport as 1 and
    comport = 1
    label_comport.Caption = "COM port: " & comport
    SetUpComport (comport)
'create freqs
    resistance = 1000000#
    createfreq

End Sub
Private Sub delay(time As Integer)
    Dim currenttime
    currenttime = Now
    If (Second(currenttime) = 59) Then
        currenttime = #5:15:00 PM#
    End If
    While (Second(Now) < (Second(currenttime) + time))
    Wend
        
End Sub


Private Sub Form_QueryUnload(cancel As Integer, UnloadMode As Integer)
    On Error GoTo ErrHandler
    If MSComm1.PortOpen Then
        MSComm1.PortOpen = False
    End If
    Exit Sub
ErrHandler:
    MsgBox "Unable to Close Port", vbOKOnly, "Active Filter Controller"
End Sub

Public Function GetComport() As Integer
    GetComport = comport
End Function
Private Sub setfreq()
    On Error Resume Next
    Dim temp As Integer
    Dim Buffer As Variant
    'temp = (128 / (6.28318530717959 * loadfreq * 0.000000001 * 1000000#)) - 1
    temp = (128 / (6.28318530717959 * loadfreq * 0.000000001 * 1000000#))
    'Buffer = Chr$(temp)
    Buffer = temp & Chr$(13)
   ' MsgBox "loadbit: " & temp & "loadfreq: " & loadfreq
    MSComm1.Output = Buffer
    delay (1)
End Sub


Private Function SetUpComport(comport) As String
    On Error GoTo errhandle
    MSComm1.Settings = "9600,n,8,1"
    MSComm1.CommPort = comport
    MSComm1.PortOpen = True
    
    
errhandle:
    If Err.Number Then
        MsgBox "COM port Invalid, please Change in ""Configue COM port"" ", vbOKOnly, "Active Filter Controller"
   ' Else
       ' MsgBox Err.Number & " " & Err.Description
    End If
    
    CheckSync
    loadfreq = 1000#
    setfreq
    
End Function
Private Sub createfreq()
'create freqs
    
    Dim i As Integer
    Dim freq As Double
    Dim res As Double
    List1.Clear
    For i = 1 To 127
         res = (i * resistance) / 128
        freq = (1 / (res * 6.28 * 0.000000001))
         List1.AddItem (Round(freq, 0) & " Hz")
    Next
    List1.DataChanged = True
End Sub


Private Sub CheckSync()
    On Error Resume Next
    Dim InString As String
    Dim Buffer As Variant
    Dim temp As Integer
    Dim counter As Integer
    'Buffer = Chr$("g")
    'Buffer = 7 & "\n"
    Buffer = 7 & Chr$(13)
    'MsgBox "Buffer:" & Buffer
    'MSComm1.InBufferCount = 0
    ' MSComm1.Output = Buffer
    ' Retrieve all available data.
    MSComm1.InputLen = 0
    temp = MSComm1.InBufferCount
    'MsgBox "justed readin1  Buffer Count=" & temp
    ' Check for data.
    If MSComm1.InBufferCount Then
        ' Read data.
        InString = MSComm1.Input
     '   MsgBox InString & " 1"
        label_sync.Caption = "SYNCHED"
        Label_notsynched.Caption = ""
    Else
        counter = 0
        While ((MSComm1.InBufferCount = 0) And (counter < 5))
            MSComm1.Output = Buffer
            'temp = MSComm1.InBufferCount
          '  MsgBox "justed outputed '7' Buffer Count=" & temp & "c=" & counter
             delay (1)
             MSComm1.InputLen = 0
            'temp = MSComm1.InBufferCount
           ' MsgBox "justed readin  Buffer Count=" & temp & "c=" & counter
            counter = counter + 1
        Wend
        If (counter < 4) Then
'            MsgBox "Sync?1  Buffer Count=" & temp & "Counter=" & counter
            InString = MSComm1.Input
            'MsgBox InString & "Counter:" & counter
            label_sync.Caption = "SYNCHED"
            Label_notsynched.Caption = ""
        Else
           ' MsgBox "Sync?2  Buffer Count=" & temp & "Counter=" & counter
            InString = MSComm1.Input
            label_sync.Caption = ""
            Label_notsynched.Caption = "NOT SYNCHED"
        End If
    End If
End Sub
Private Sub ConfigCom_Click()
'Configure com port
    comsettings.Show vbModal
    If Not (comsettings.GetComport = comport) Then
        'reset comsettings
        comport = comsettings.GetComport
        label_comport.Caption = "COM port: " & comport
        SetUpComport (comport)
    End If
    
End Sub

Private Sub Exit_Click()
 Unload Me
End Sub

Private Sub resync_Click()
    MsgBox "Please reset the device and click OK", vbOKOnly, "Active Filter Controller"
    CheckSync
    loadfreq = 1000
    setfreq
End Sub
Private Sub calibrate_Click()
    Calibrate_form.Show vbModal
    resistance = Calibrate_form.GetResis
    'create freqs
    createfreq
End Sub
Private Sub set_freq_Click()
'Set Freq Button
On Error Resume Next
    Label_Freqout.Caption = "Current Frequency: " & List1.List(List1.ListIndex) '& " Hz"
    CheckSync
    loadfreq = Replace(List1.List(List1.ListIndex), "Hz", "", 1, -1, vbTextCompare)
    setfreq
End Sub
