;CodeVisionAVR C Compiler V1.0.0.8v Evaluation
;(C) Copyright 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.
;http://infotech.ir.ro
;e-mail:dhptechn@ir.ro , hpinfotech@mail.com

;Chip type        : AT90S8515
;Clock frequency  : 4.000000 MHz
;Memory model     : Small
;Internal RAM size: 512
;External RAM size: 0
;Data Stack size  : 128
;Automatic register allocation: On
;Use AVR Studio Terminal I/O  : No

	.DEVICE AT90S8515
	.LISTMAC
	.EQU UDRE=5
	.EQU RXC=7
	.EQU UBRR=9
	.EQU UCR=0xA
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0
	.EQU EEWE=1
	.EQU EEMWE=2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x10

	.MACRO __EQB10
	TST  R30
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB10
	CPI  R30,0
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB10
	CLR  R0
	CP   R0,R30
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB10
	CLR  R0
	CP   R0,R30
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB10
	CPI  R30,0
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB10
	TST  R30
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQW10
	SBIW R30,0
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEW10
	SBIW R30,0
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTW10
	RCALL __CPW01
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEW10
	RCALL __CPW01
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTW10
	SBIW R30,0
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEW10
	SBIW R30,0
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQD10
	RCALL __CPD10
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GED10
	RCALL __CPD10
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTD10
	RCALL __CPD01
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LED10
	RCALL __CPD01
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTD10
	RCALL __CPD10
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NED10
	RCALL __CPD10
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQB12J
	CP   R30,R26
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB12J
	CP   R30,R26
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB12J
	CP   R30,R26
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB12J
	CP   R26,R30
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB12J
	CP   R26,R30
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB12J
	CP   R30,R26
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB12UJ
	CP   R30,R26
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB12UJ
	CP   R26,R30
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB12UJ
	CP   R26,R30
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB12UJ
	CP   R30,R26
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQW12J
	CP   R30,R26
	CPC  R31,R27
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEW12J
	CP   R30,R26
	CPC  R31,R27
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEW12J
	CP   R30,R26
	CPC  R31,R27
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEW12J
	CP   R26,R30
	CPC  R27,R31
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTW12J
	CP   R26,R30
	CPC  R27,R31
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTW12J
	CP   R30,R26
	CPC  R31,R27
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEW12UJ
	CP   R30,R26
	CPC  R31,R27
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEW12UJ
	CP   R26,R30
	CPC  R27,R31
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTW12UJ
	CP   R26,R30
	CPC  R27,R31
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTW12UJ
	CP   R30,R26
	CPC  R31,R27
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQD12J
	RCALL __CPD12
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NED12J
	RCALL __CPD12
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LED12J
	RCALL __CPD12
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GED12J
	RCALL __CPD21
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTD12J
	RCALL __CPD21
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTD12J
	RCALL __CPD12
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LED12UJ
	RCALL __CPD12
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GED12UJ
	RCALL __CPD21
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTD12UJ
	RCALL __CPD21
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTD12UJ
	RCALL __CPD12
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEF12J
	RCALL __CMPF12
	BREQ __TRUE
	BRCS __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEF12J
	RCALL __CMPF12
	BREQ __TRUE
	BRCC __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTF12J
	RCALL __CMPF12
	BREQ __FALSE
	BRCS __TRUE
__FALSE:
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTF12J
	RCALL __CMPF12
	BREQ __FALSE
	BRCC __TRUE
__FALSE:
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQB1NJ
	CPI  R30,LOW(@1)
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB1NJ
	CPI  R30,LOW(@1)
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQB2NJ
	CPI  R26,LOW(@1)
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB2NJ
	CPI  R26,LOW(@1)
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB1NJ
	CPI  R30,LOW(@1)
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB1NJ
	CPI  R30,LOW(@1)
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB1NJ
	CPI  R30,LOW(@1)
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB1NJ
	CPI  R30,LOW(@1)
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB1NUJ
	CPI  R30,LOW(@1)
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB1NUJ
	CPI  R30,LOW(@1)
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB1NUJ
	CPI  R30,LOW(@1)
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB1NUJ
	CPI  R30,LOW(@1)
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB2NJ
	CPI  R26,LOW(@1)
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB2NJ
	CPI  R26,LOW(@1)
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB2NUJ
	CPI  R26,LOW(@1)
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB2NUJ
	CPI  R26,LOW(@1)
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __BITSREG0
	BRBC @0,__TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __BITSREG1
	BRBS @0,__TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __EQBR0
	TST  R@0
	BREQ __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBR0
	TST  R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBR0
	CLR  R0
	CP   R0,R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBR0
	CLR  R0
	CP   R0,R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBR0
	TST  R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __NEBR0
	TST  R@0
	BRNE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __EQBRRJ
	CP   R@0,R@1
	BREQ __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __NEBRRJ
	CP   R@0,R@1
	BRNE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEBRRJ
	CP   R@0,R@1
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEBRRJ
	CP   R@1,R@0
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTBRRJ
	CP   R@1,R@0
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTBRRJ
	CP   R@0,R@1
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEBRRUJ
	CP   R@0,R@1
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEBRRUJ
	CP   R@1,R@0
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTBRRUJ
	CP   R@1,R@0
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTBRRUJ
	CP   R@0,R@1
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __EQWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BREQ __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __NEWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRNE __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LEWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRGE __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GEWRRJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRGE __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LTWRRJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRLT __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GTWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRLT __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LEWRRUJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRSH __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GEWRRUJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRSH __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LTWRRUJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRLO __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GTWRRUJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRLO __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LEB1RJ
	CP   R30,R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEB1RJ
	CP   R@0,R30
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTB1RJ
	CP   R@0,R30
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTB1RJ
	CP   R30,R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEB1RUJ
	CP   R30,R@0
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEB1RUJ
	CP   R@0,R30
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTB1RUJ
	CP   R@0,R30
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTB1RUJ
	CP   R30,R@0
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBR2J
	CP   R@0,R26
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBR2J
	CP   R26,R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBR2J
	CP   R26,R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBR2J
	CP   R@0,R26
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBR2UJ
	CP   R@0,R26
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBR2UJ
	CP   R26,R@0
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBR2UJ
	CP   R26,R@0
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBR2UJ
	CP   R@0,R26
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEW1RJ
	CP   R30,R@0
	CPC  R31,R@1
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEW1RJ
	CP   R@0,R30
	CPC  R@1,R31
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTW1RJ
	CP   R@0,R30
	CPC  R@1,R31
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTW1RJ
	CP   R30,R@0
	CPC  R31,R@1
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEW1RUJ
	CP   R30,R@0
	CPC  R31,R@1
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEW1RUJ
	CP   R@0,R30
	CPC  R@1,R31
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTW1RUJ
	CP   R@0,R30
	CPC  R@1,R31
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTW1RUJ
	CP   R30,R@0
	CPC  R31,R@1
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEWR2J
	CP   R@0,R26
	CPC  R@1,R27
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEWR2J
	CP   R26,R@0
	CPC  R27,R@1
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTWR2J
	CP   R26,R@0
	CPC  R27,R@1
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTWR2J
	CP   R@0,R26
	CPC  R@1,R27
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEWR2UJ
	CP   R@0,R26
	CPC  R@1,R27
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEWR2UJ
	CP   R26,R@0
	CPC  R27,R@1
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTWR2UJ
	CP   R26,R@0
	CPC  R27,R@1
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTWR2UJ
	CP   R@0,R26
	CPC  R@1,R27
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __EQBRNJ
	CPI  R@0,LOW(@2)
	BREQ __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __NEBRNJ
	CPI  R@0,LOW(@2)
	BRNE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBRNJ
	CPI  R@0,LOW(@2)
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBRNJ
	CPI  R@0,LOW(@2)
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBRNJ
	CPI  R@0,LOW(@2)
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBRNJ
	CPI  R@0,LOW(@2)
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBRNUJ
	CPI  R@0,LOW(@2)
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBRNUJ
	CPI  R@0,LOW(@2)
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBRNUJ
	CPI  R@0,LOW(@2)
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBRNUJ
	CPI  R@0,LOW(@2)
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __TESTSREG
	LDI  R30,1
	BRBS @0,__TRUE
	LDI  R30,0
__TRUE:
	.ENDM

	.MACRO __NTESTSREG
	LDI  R30,1
	BRBC @0,__TRUE
	LDI  R30,0
__TRUE:
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.CSEG
	.ORG 0x0D

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;DISABLE WATCHDOG
	LDI  R30,0x18
	OUT  WDTCR,R30
	LDI  R30,0x10
	OUT  WDTCR,R30
	CLR  R30
	OUT  MCUCR,R30

;CLEAR R2-R15
	LDI  R24,14
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR RAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_RAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_RAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	MOV  R1,R0
	ADIW R30,1
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM
	MOV  R26,R0
	ADIW R30,1
	LPM
	MOV  R27,R0
	ADIW R30,1
	LPM
	MOV  R24,R0
	ADIW R30,1
	LPM
	MOV  R25,R0
	ADIW R30,1
__GLOBAL_INI_LOOP:
	LPM
	ST   X+,R0
	ADIW R30,1
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xDF)
	LDI  R29,HIGH(0xDF)

;UART BAUD RATE INITIALIZATION
	LDI  R30,0x19
	OUT  UBRR,R30

	RJMP  _main

	.ESEG
	.ORG 1

	.DSEG
	.ORG 0xE0
;       1 /***************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.0.0.8v Evaluation
;       4 Automatic Program Generator
;       5  Copyright 1998-2000
;       6 Pavel Haiduc, HP InfoTech S.R.L.
;       7 http://infotech.ir.ro
;       8 e-mail:dhptechn@ir.ro , hpinfotech@mail.com
;       9 
;      10 Project : uart
;      11 Version : 
;      12 Date    : 10/21/2000
;      13 Author  : 
;      14 Company : 
;      15 Comments: 
;      16 
;      17 
;      18 Chip type        : AT90S4414
;      19 Clock frequency  : 4.000000 MHz
;      20 Memory model     : Tiny
;      21 Internal RAM size: 256
;      22 External RAM size: 0
;      23 Data Stack size  : 64
;      24 ***************************************/
;      25 
;      26 #include <90s8515.h>
;      27 // CodeVisionAVR C Compiler
;      28 // (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.
;      29 
;      30 // I/O registers definitions for the AT90S8515
;      31 
;      32 #pragma used+
;      33 sfrb ACSR=8;
;      34 sfrb UBRR=9;
;      35 sfrb UCR=0xa;
;      36 sfrb USR=0xb;
;      37 sfrb UDR=0xc;
;      38 sfrb SPCR=0xd;
;      39 sfrb SPSR=0xe;
;      40 sfrb SPDR=0xf;
;      41 sfrb PIND=0x10;
;      42 sfrb DDRD=0x11;
;      43 sfrb PORTD=0x12;
;      44 sfrb PINC=0x13;
;      45 sfrb DDRC=0x14;
;      46 sfrb PORTC=0x15;
;      47 sfrb PINB=0x16;
;      48 sfrb DDRB=0x17;
;      49 sfrb PORTB=0x18;
;      50 sfrb PINA=0x19;
;      51 sfrb DDRA=0x1a;
;      52 sfrb PORTA=0x1b;
;      53 sfrb EECR=0x1c;
;      54 sfrb EEDR=0x1d;
;      55 sfrb EEARL=0x1e;
;      56 sfrb EEARH=0x1f;
;      57 sfrw EEAR=0x1e;   // 16 bit access
;      58 sfrb WDTCR=0x21;
;      59 sfrb ICR1L=0x24;
;      60 sfrb ICR1H=0x25;
;      61 sfrw ICR1=0x24;   // 16 bit access
;      62 sfrb OCR1BL=0x28;
;      63 sfrb OCR1BH=0x29;
;      64 sfrw OCR1B=0x28;  // 16 bit access
;      65 sfrb OCR1AL=0x2a;
;      66 sfrb OCR1AH=0x2b;
;      67 sfrw OCR1A=0x2a;  // 16 bit access
;      68 sfrb TCNT1L=0x2c;
;      69 sfrb TCNT1H=0x2d;
;      70 sfrw TCNT1=0x2c;  // 16 bit access
;      71 sfrb TCCR1B=0x2e;
;      72 sfrb TCCR1A=0x2f;
;      73 sfrb TCNT0=0x32;
;      74 sfrb TCCR0=0x33;
;      75 sfrb MCUSR=0x34;
;      76 sfrb MCUCR=0x35;
;      77 sfrb TIFR=0x38;
;      78 sfrb TIMSK=0x39;
;      79 sfrb GIFR=0x3a;
;      80 sfrb GIMSK=0x3b;
;      81 sfrb SPL=0x3d;
;      82 sfrb SPH=0x3e;
;      83 sfrb SREG=0x3f;
;      84 #pragma used-
;      85 
;      86 // Interrupt vectors definitions
;      87 
;      88 #define EXT_INT0 2
;      89 #define EXT_INT1 3
;      90 #define TIM1_CAPT 4
;      91 #define TIM1_COMPA 5
;      92 #define TIM1_COMPB 6
;      93 #define TIM1_OVF 7
;      94 #define TIM0_OVF 8
;      95 #define SPI_STC 9
;      96 #define UART_RXC 10
;      97 #define UART_DRE 11
;      98 #define UART_TXC 12
;      99 #define ANA_COMP 13
;     100 
;     101 
;     102 
;     103 // Standard Input/Output functions
;     104 #include <stdio.h>
;     105 // CodeVisionAVR C Compiler
;     106 // (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.
;     107 
;     108 // Prototypes for standard I/O functions
;     109 
;     110 #pragma used+
;     111 
;     112 #pragma warn-
;     113 #ifndef _DEBUG_TERMINAL_IO_
;     114 #ifndef _ALTERNATE_GETCHAR_
;     115 char getchar(void)
;     116 {

	.CSEG
_getchar:
;     117 #asm
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
;     121 #endasm
;     122 }
	RET
;     123 #endif
;     124 
;     125 #ifndef _ALTERNATE_PUTCHAR_
;     126 void putchar(char c)
;     127 {
_putchar:
;     128 #asm
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
;     133 #endasm
;     134 }
	ADIW R28,1
	RET
;     135 #endif
;     136 #else
;     137 // Used for AVR Studio Terminal I/O
;     138 // DON'T CHANGE!
;     139 void getchar(void)
;     140 {
;     141 #asm
;     142      push  r16
;     143      push  r17
;     144 __getchar0:
;     145      rcall __c_getchar
;     146      cpi   r17,0xff
;     147      breq  __getchar0
;     148      mov   r30,r16
;     149      pop   r17
;     150      pop   r16
;     151 #endasm
;     152 }
;     153 
;     154 void putchar(char c)
;     155 {
;     156 #asm
;     157     mov   r30,r16
;     158     ld    r16,y
;     159     rcall __c_putchar
;     160     mov   r16,r30
;     161 #endasm
;     162 }
;     163 
;     164 void _c_getchar(void)
;     165 {
;     166 }
;     167 
;     168 void _c_putchar(void)
;     169 {
;     170 }
;     171 #endif
;     172 
;     173 #ifdef _WARNINGS_ON_
;     174 #pragma warn+
;     175 #endif
;     176 
;     177 void puts(char *str);
;     178 void putsf(char flash *str);
;     179 
;     180 #ifdef _MODEL_TINY_
;     181 char *gets(char *str,unsigned char len);
;     182 #endif
;     183 
;     184 #ifdef _MODEL_SMALL_
;     185 char *gets(char *str,unsigned int len);
;     186 #endif
;     187 
;     188 #pragma parptr+
;     189 void printf(char flash *fmtstr);
;     190 void sprintf(char *str, char flash *fmtstr);
;     191 char scanf(char flash *fmtstr);
;     192 char sscanf(char *str,char flash *fmtstr);
;     193 #pragma parptr-
;     194 
;     195 #pragma used-
;     196 
;     197 
;     198 
;     199 // delays
;     200 #include <delay.h>
;     201 // CodeVisionAVR C Compiler
;     202 // (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.
;     203 
;     204 #ifndef _DELAY_USED_
;     205 #pragma used+
;     206 
;     207 void delay_us(unsigned int n);
;     208 void delay_ms(unsigned int n);
;     209 
;     210 #pragma used-
;     211 #define _DELAY_USED_
;     212 #endif
;     213 
;     214 #define CLK_PULSE 5
;     215 #define PI 3.14159265359       
;     216 #define CAP1 1e-9
;     217 #define RPAD 100e3
;     218 
;     219 // Declare your global variables here 
;     220 //unsigned char loadbit; 
;     221 //int freq; 
;     222 
;     223 unsigned char convert(int freq) {
_convert:
;     224 	//convert freq into load bits
;     225 	//R = 1/(2pifC)               
;     226 	//then loadbit = (R/1M)*128  
;     227 	unsigned char loadbit;
;     228 // 1M only
;     229  	loadbit = (unsigned char) (128/(2*PI*freq*CAP1*1e6)); 
	ST   -Y,R16
;	freq -> Y+1
;	loadbit -> R16
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	__GETD2N 0x40C90FDB
	RCALL __CWD1
	RCALL __CDF1
	RCALL __MULF12
	__GETD2N 0x3089705F
	RCALL __MULF12
	__GETD2N 0x49742400
	RCALL __MULF12
	__GETD2N 0x43000000
	RCALL __DIVF21
	RCALL __CFD1
	MOV  R16,R30
;     230 //1M with pad of 100k
;     231   //	resis =  (1/(2*PI*freq*CAP1);
;     232   //	resis = (resis*RPAD)/(RPAD-resis);
;     233   //	loadbit = (resis*128/1e6); 
;     234  	printf("loadbit = %d \n",loadbit);
	PUSH R29
	PUSH R28
	LDI  R30,LOW(_12*2+0)
	LDI  R31,HIGH(_12*2+0)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	RCALL _printf
	ADIW R28,4
;     235  	return loadbit;
	MOV  R30,R16
	LDD  R16,Y+0
	ADIW R28,3
	RET
;     236 }             
_12:
	.DB   0x6C,0x6F,0x61,0x64,0x62,0x69,0x74,0x20
	.DB   0x3D,0x20,0x25,0x64,0x20,0xA,0x0
;     237 
;     238 void set_VR(unsigned char loadbit)
;     239 {
_set_VR:
;     240 	int i;     
;     241 	unsigned char tempout;
;     242 	printf("inside set_VR \n"); 
	RCALL __SAVELOCR3
;	loadbit -> Y+3
;	i -> R16,R17
;	tempout -> R18
	PUSH R29
	PUSH R28
	LDI  R30,LOW(_13*2+0)
	LDI  R31,HIGH(_13*2+0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _printf
	ADIW R28,2
;     243 	printf("loadbit = %d \n",loadbit);
	PUSH R29
	PUSH R28
	LDI  R30,LOW(_13*2+16)
	LDI  R31,HIGH(_13*2+16)
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+5
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	RCALL _printf
	ADIW R28,4
;     244 		
;     245 //bring cs high and clk low
;     246 	PORTB = 0x02;
	LDI  R30,LOW(2)
	OUT  0x18,R30
;     247 	delay_ms(CLK_PULSE);
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     248 //bring down clock
;     249 	//PORTB= 0x02;
;     250 	//delay_ms(CLK_PULSE);
;     251 //bring cs low
;     252 	PORTB = 0x00;       
	CLR  R30
	OUT  0x18,R30
;     253 	delay_ms(CLK_PULSE);
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     254 	for (i= 0; i<7; i++){
	__GETWRN 16,17,0
_0x10:
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	__LTW1RJ 16,17,15
	RJMP _0x11
_0xE:
	__ADDWRN 16,17,1
	RJMP _0x10
_0x11:
;     255 	//set up the data 
;     256 		loadbit = (loadbit<<1);
	LDD  R30,Y+3
	LSL  R30
	STD  Y+3,R30
;     257 		tempout = ((loadbit & 0x80)>>5);
	LDD  R30,Y+3
	ANDI R30,LOW(0x80)
	MOV  R26,R30
	LDI  R30,LOW(5)
	RCALL __LSRB12
	MOV  R18,R30
;     258 		PORTB = (tempout);
	OUT  0x18,R18
;     259 		delay_ms(CLK_PULSE);
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     260 	//rise the clock
;     261 		PORTB = (tempout | 0x01);
	MOV  R30,R18
	ORI  R30,1
	OUT  0x18,R30
;     262 		delay_ms(CLK_PULSE);
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     263 	//drop the clock
;     264 		PORTB = (0x00);
	CLR  R30
	OUT  0x18,R30
;     265 		delay_ms(CLK_PULSE);   
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     266 	}
	RJMP _0xE
_0xF:
;     267 //set CS high
;     268 	PORTB = 0x02;
	LDI  R30,LOW(2)
	OUT  0x18,R30
;     269 	delay_ms(CLK_PULSE);
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     270 }   
	RCALL __LOADLOCR3
	ADIW R28,4
	RET
_13:
	.DB   0x69,0x6E,0x73,0x69,0x64,0x65,0x20,0x73
	.DB   0x65,0x74,0x5F,0x56,0x52,0x20,0xA,0x0
	.DB   0x6C,0x6F,0x61,0x64,0x62,0x69,0x74,0x20
	.DB   0x3D,0x20,0x25,0x64,0x20,0xA,0x0
;     271 void main(void)
;     272 {
_main:
;     273 // Declare your local variables here
;     274    unsigned int myint;
;     275 // the LED on  output 0 will be on
;     276 
;     277 // Input/Output Ports initialization
;     278 // Port A
;     279 DDRA=0x00;
;	myint -> R16,R17
	CLR  R30
	OUT  0x1A,R30
;     280 PORTA=0x00;
	OUT  0x1B,R30
;     281 
;     282 // Port B 
;     283 DDRB=0xff;
	LDI  R30,LOW(255)
	OUT  0x17,R30
;     284 PORTB=0x02; //setup clock low and CS low
	LDI  R30,LOW(2)
	OUT  0x18,R30
;     285 
;     286 // Port C
;     287 DDRC=0x00;
	CLR  R30
	OUT  0x14,R30
;     288 PORTC=0x00;
	OUT  0x15,R30
;     289 
;     290 // Port D
;     291 DDRD=0x00;
	OUT  0x11,R30
;     292 PORTD=0x00;
	OUT  0x12,R30
;     293 
;     294 // Timer/Counter 0 initialization
;     295 // Clock source: System Clock
;     296 // Clock value: Timer 0 Stopped
;     297 // Mode: Output Compare
;     298 // OC0 output: Disconnected
;     299 TCCR0=0x00;
	OUT  0x33,R30
;     300 TCNT0=0x00;
	OUT  0x32,R30
;     301 
;     302 // Timer/Counter 1 initialization
;     303 // Clock source: System Clock
;     304 // Clock value: Timer 1 Stopped
;     305 // Mode: Output Compare
;     306 // OC1A output: Discon.
;     307 // OC1B output: Discon.
;     308 // Noise Canceler: Off
;     309 // Input Capture on Falling Edge
;     310 TCCR1A=0x00;
	OUT  0x2F,R30
;     311 TCCR1B=0x00;
	OUT  0x2E,R30
;     312 TCNT1H=0x00;
	OUT  0x2D,R30
;     313 TCNT1L=0x00;
	OUT  0x2C,R30
;     314 OCR1AH=0x00;
	OUT  0x2B,R30
;     315 OCR1AL=0x00;
	OUT  0x2A,R30
;     316 OCR1BH=0x00;
	OUT  0x29,R30
;     317 OCR1BL=0x00;
	OUT  0x28,R30
;     318 
;     319 // UART initialization
;     320 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     321 // UART Receiver: On
;     322 // UART Transmitter: On
;     323 UCR=0x18;
	LDI  R30,LOW(24)
	OUT  0xA,R30
;     324 // UART Baud rate: 9600
;     325 UBRR=0x19;
	LDI  R30,LOW(25)
	OUT  0x9,R30
;     326 
;     327 // Analog Comparator initialization
;     328 // Analog Comparator: Off
;     329 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     330 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     331 
;     332                        
;     333 
;     334 while (1)
_0x13:
;     335 {
;     336       // test loop
;     337 	printf("Inside Main\n");      
	PUSH R29
	PUSH R28
	LDI  R30,LOW(_18*2+0)
	LDI  R31,HIGH(_18*2+0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _printf
	ADIW R28,2
;     338  	printf("Enter in a number:\n");      
	PUSH R29
	PUSH R28
	LDI  R30,LOW(_18*2+13)
	LDI  R31,HIGH(_18*2+13)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _printf
	ADIW R28,2
;     339   	scanf("%d",&myint);
	PUSH R29
	PUSH R28
	LDI  R30,LOW(_18*2+33)
	LDI  R31,HIGH(_18*2+33)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _scanf
	ADIW R28,4
;     340    	printf("my value is: %d \n",myint);
	PUSH R29
	PUSH R28
	LDI  R30,LOW(_18*2+36)
	LDI  R31,HIGH(_18*2+36)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	RCALL _printf
	ADIW R28,4
;     341     //set_VR(convert(myint)); 
;     342     set_VR((unsigned char) myint); 
	__GETW1R 16,17
	ST   -Y,R30
	RCALL _set_VR
;     343  }
	RJMP _0x13
_0x14:
;     344 
;     345 }
	RET
_18:
	.DB   0x49,0x6E,0x73,0x69,0x64,0x65,0x20,0x4D
	.DB   0x61,0x69,0x6E,0xA,0x0,0x45,0x6E,0x74
	.DB   0x65,0x72,0x20,0x69,0x6E,0x20,0x61,0x20
	.DB   0x6E,0x75,0x6D,0x62,0x65,0x72,0x3A,0xA
	.DB   0x0,0x25,0x64,0x0,0x6D,0x79,0x20,0x76
	.DB   0x61,0x6C,0x75,0x65,0x20,0x69,0x73,0x3A
	.DB   0x20,0x25,0x64,0x20,0xA,0x0

__GLOBAL_INI_TBL:
	.DW  0

_printf:
	pop  r31
	pop  r30
	pop  r26
	pop  r27
	push r30
	push r31
	ld   r31,-x
	ld   r30,-x
	ser  r23
__printf0:
	tst  r23
	brmi __printf9
	breq __printf9
	ldi  r22,' '
	rcall __printf_char
	rjmp __printf0
__printf9:
	ldi  r24,' '
	clr  r25
__printf5:
	lpm
	adiw r30,1
	mov  r22,r0
	tst  r22
	brne __printf1
	ret
__printf1:
	sbrc r25,0
	rjmp __printf3
	cpi  r22,'%'
	breq __printf2
	rcall __printf_char
	rjmp __printf0
__printf2:
	sbr  r25,1
	rjmp __printf5
__printf3:
	cpi  r22,'%'
	brne __printf8
	rcall __printf_char
	rjmp __printf0
__printf8:
	cpi  r22,'-'
	brne __printf6
	sbr  r25,2
	rjmp __printf5
__printf6:
	cpi  r22,'0'
	brne __printf4
	sbrc r25,1
	rjmp __printf5
	mov  r24,r22
	rjmp __printf5
__printf4:
	cpi  r22,'9'+1
	brsh __printf7
	subi r22,'0'
	brlo __printf7
	mov  r23,r22
	rjmp __printf5
__printf7:
	cpi  r22,'s'
	breq __printfs
	cpi  r22,'c'
	breq __printfc
	cpi  r22,'d'
	breq __printfi
	cpi  r22,'i'
	breq __printfi
	cpi  r22,'u'
	breq __printfu
	cpi  r22,'X'
	breq __printfx1
	cpi  r22,'x'
	brne __printf2
	sbr  r25,8
__printfx1:
	rjmp __printfx
__printfs:
	push   r30
	push   r31
	ld   r31,-x
	ld   r30,-x
__printfs0:
	ld   r22,z+
	tst  r22
	breq __printfs1
	rcall __printf_char
	rjmp __printfs0
__printfs1:
	pop  r31
	pop  r30
	rjmp __printf0
__printfc:
	sbiw r26,2
	ld   r22,x
	rcall __printf_char
	rjmp __printf0
__printfi:
	ldi  r22,7
	rcall __printf_pad0
	sbr  r25,4
	ld   r1,-x
	ld   r0,-x
	push r26
	push r27
	ldi  r26,1
	clr  r27
	cp   r0,r27
	cpc  r1,r27
	brpl __printfi0
	com  r0
	com  r1
	add  r0,r26
	adc  r1,r27
	sbr  r25,0x80
	rjmp __printfi0
__printfu:
	ldi  r22,6
	rcall __printf_pad0
	ld   r1,-x
	ld   r0,-x
	push r26
	push r27
__printfi0:
	push r30
	ldi  r26,low(10000)
	ldi  r27,high(10000)
	ldi  r30,6
	sbrc r25,2
	inc  r30
	rcall __printfu0
	ldi  r26,low(1000)
	ldi  r27,high(1000)
	rcall __printfu0
	ldi  r26,100
	clr  r27
	rcall __printfu0
	ldi  r26,10
	rcall __printfu0
	mov  r22,r0
	pop  r30
	pop  r27
	pop  r26
	rcall __printf_digit0
	rjmp __printf0
__printfx:
	ldi  r22,5
	rcall __printf_pad0
	ld   r22,-x
	push r30
	ldi  r30,5
	rcall __printf_xbyte
	ld   r22,-x
	sbr  r25,0x40
	rcall __printf_xbyte
	pop  r30
	rjmp __printf0
__printf_xbyte:
	mov  r0,r22
	swap r22
	rcall __printf_xnibble
	mov  r22,r0
	sbrc r25,6
	sbr  r25,0x20
__printf_xnibble:
	andi r22,0xf
__printf_digit:
	dec  r30
	tst  r22
	brne __printf_digit0
	cp   r23,r30
	sbrs r25,4
	brlo __printf_left0
	sbrc r25,5
	rjmp __printf_digit4
	sbrc r25,1
	rjmp __printf_left
	cpi  r24,'0'
	brne __printf_pad
	sbrc r25,7
	rcall __printf_minus
	rjmp __printf_pad
__printf_left:
	sbrs r25,7
__printf_left0:
	ret
__printf_minus:
	cbr  r25,0x84
	ldi  r22,'-'
	rjmp __printf_char
__printf_pad:
	mov  r22,r24
	rjmp __printf_char
__printf_digit0:
	sbr  r25,0x10
	sbrs r25,2
	rjmp __printf_digit1
	cbr  r25,4
	push r22
	sbrs r25,7
	rjmp __printf_digit3
	rcall __printf_minus
	rjmp __printf_digit2
__printf_digit3:
	sbrc r25,1
	rjmp __printf_digit2
	rcall __printf_pad
__printf_digit2:
	pop  r22
__printf_digit1:
	cbr  r25,2
	ldi  r24,'0'
__printf_digit4:
	subi r22,-0x30
	cpi  r22,'9'+1
	brlo __printf_char
	subi r22,-7
	sbrc r25,3
	sbr  r22,0x20
__printf_char:
	tst  r23
	brmi __printf_char0
	dec  r23
__printf_char0:
	push r26
	push r27
	push r30
	push r31
	st   -y,r22
	rcall _putchar
	pop  r31
	pop  r30
	pop  r27
	pop  r26
	ret
__printfu0:
	clr	 r22
__printfu1:
	cp   r0,r26
	cpc  r1,r27
	brlo __printf_digit
	inc  r22
	sub  r0,r26
	sbc  r1,r27
	brne __printfu1
	rjmp __printf_digit

__printf_pad0:
	sbrc r25,1
__printf_pad2:
	ret
	mov  r1,r22
__printf_pad1:
	cp   r23,r1
	brlt __printf_pad2
	rcall __printf_pad
	rjmp __printf_pad1

_scanf:
	pop  r31
	pop  r30
	pop  r26
	pop  r27
	push r30
	push r31
	ld   r31,-x
	ld   r30,-x
	clr  r23
__scanf0:
	clt
__scanf1:
	lpm
	adiw r30,1
	tst  r0
	brne __scanf9
	mov  r30,r23
	tst  r30
	brne __scanf10
	ldi  r30,-1
__scanf10:
	ret
__scanf9:
	mov  r22,r0
	brts __scanf2
	cpi  r22,'%'
	brne __scanf1
	set
	rjmp __scanf1
__scanf2:
	cpi  r22,'c'
	breq __scanfc
	cpi  r22,'s'
	breq __scanfs
	cpi  r22,'i'
	breq __scanfi
	cpi  r22,'d'
	breq __scanfi
	cpi  r22,'u'
	breq __scanfu
	cpi  r22,'x'
	brne __scanf0
	rjmp __scanfx
__scanfc:
	rcall __scanf8
	breq __scanf0
	rcall __scanf7
	breq __scanfc
	rcall __scanf3
__scanfc0:
	st   z,r22
	mov  r30,r0
	mov  r31,r1
	inc  r23
	rjmp __scanf0
__scanfs:
	rcall __scanf8
	breq __scanf0
	rcall __scanf7
	breq __scanfs
	rcall __scanf3
__scanfs0:
	st   z+,r22
	rcall __scanf8
	breq __scanfs1
	rcall __scanf7
	brne __scanfs0
__scanfs1:
	clr  r22
	rjmp __scanfc0
__scanfu:
	rcall __scanf8
	breq __scanf0
	rcall __scanf7
	breq __scanfu
	clt
	cpi  r22,'+'
	brne __scanfi1
	rcall __scanf8
	rjmp __scanfi1
__scanfi:
	rcall __scanf8
	breq __scanf0
	rcall __scanf7
	breq __scanfi
	rcall __scanf4
__scanfi1:
	clr  r24
	clr  r25
__scanfi2:
	cpi  r22,'0'
	brlo  __scanfi3
	cpi  r22,'9'+1
	brcc  __scanfi3
	mov  r0,r24
	mov  r1,r25
	lsl  r24
	rol  r25
	lsl  r24
	rol  r25
	add  r24,r0
	adc  r25,r1
	lsl  r24
	rol  r25
	clr  r0
	subi r22,'0'
	add  r24,r22
	adc  r25,r0
	rcall __scanf8
	rjmp __scanfi2
__scanfi3:
	brtc __scanfi4
	com  r24
	com  r25
	adiw r24,1
__scanfi4:
	rcall __scanf3
	st   z+,r24
	st   z,r25
	mov  r30,r0
	mov  r31,r1
	inc  r23
__scanfi5:
	rjmp __scanf0
__scanfx:
	rcall __scanf8
	breq __scanfi5
	rcall __scanf7
	breq __scanfx
	rcall __scanf4
	clr  r24
	clr  r25
__scanfx0:
	cpi  r22,'a'
	brlo __scanfx1
	cpi  r22,'f'+1
	brcc __scanfx1
	cbr  r22,0x20
__scanfx1:
	subi r22,'0'
	brlo __scanfi3
	cpi  r22,10
	brlo __scanfx2
	subi r22,7
	cpi  r22,10
	brlo __scanfi3
	cpi  r22,16
	brcc __scanfi3
__scanfx2:
	lsl  r24
	rol  r25
	lsl  r24
	rol  r25
	lsl  r24
	rol  r25
	lsl  r24
	rol  r25
	clr  r0
	add  r24,r22
	adc  r25,r0
	rcall __scanf8
	rjmp __scanfx0
__scanf3:
	mov  r0,r30
	mov  r1,r31
	ld   r31,-x
	ld   r30,-x
	ret
__scanf7:
	cpi  r22,9
	breq __scanf6
	cpi  r22,10
	breq __scanf6
	cpi  r22,13
	breq __scanf6
	cpi  r22,' '
__scanf6:
	ret
__scanf4:
	clt
	cpi  r22,'+'
	breq __scanf8
	cpi  r22,'-'
	brne __scanf6
	set
__scanf8:
	push r26
	push r27
	push r30
	push r31
	rcall _getchar
	mov  r22,r30
	tst  r22
	pop  r31
	pop  r30
	pop  r27
	pop  r26
	ret

_delay_ms:
	ld   r30,y
	ldd  r31,y+1
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	adiw r28,2
	ret

__ANEGD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSRB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSRB12R
__LSRB12L:
	LSR  R30
	DEC  R0
	BRNE __LSRB12L
__LSRB12R:
	RET

__CWD1:
	CLR  R22
	CLR  R23
	SBRS R31,7
	RET
	SER  R22
	SER  R23
	RET

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BREQ __CFD10
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	RJMP __MAXRES
__CFD11:
	CPI  R21,24
	BRLO __CFD12
__CFD10:
	RJMP __MINRES
__CFD12:
	CLR  R23
__CFD13:
	CPI  R21,8
	BRLO __CFD14
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD13
__CFD14:
	TST  R21
	BREQ __CFD16
__CFD15:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD15
__CFD16:
	CLR  R23
	TST  R0
	BRPL __CFD17
	RCALL __NEGMAN1
	SER  R23
__CFD17:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1

__REPACK:
	LSL  R22
	LDI  R21,0x80
	EOR  R21,R23
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
__CDF10:
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__MAXRES:
	SER  R30
	SER  R31
	ORI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MINRES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __MINRES
	CPI  R25,0x80
	BREQ __MINRES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVS __MAXRES
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,24
__MULF120:
	LSL  R19
	ROL  R20
	ROL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	BRCC __MULF121
	ADD  R19,R26
	ADC  R20,R27
	ADC  R21,R24
	ADC  R30,R1
	ADC  R31,R1
	ADC  R22,R1
__MULF121:
	DEC  R25
	BRNE __MULF120
	POP  R20
	POP  R19
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MAXRES
__MULF123:
	RCALL __REPACK
	POP  R21
	RET

__DIVF21:
	PUSH R21
	TST  R23
	BRNE __DIVF211
__DIVF210:
	RJMP __MAXRES
__DIVF211:
	TST  R25
	BREQ __MINRES
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __MINRES
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVS __DIVF210
	MOV  R23,R25
	LSR  R22
	ROR  R31
	ROR  R30
	LSR  R24
	ROR  R27
	ROR  R26
	PUSH R20
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R25,24
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R1
	ROL  R20
	ROL  R21
	ROL  R26
	ROL  R27
	ROL  R24
	DEC  R25
	BRNE __DIVF212
	MOV  R30,R1
	MOV  R31,R20
	MOV  R22,R21
	LSR  R26
	ADC  R30,R25
	ADC  R31,R25
	ADC  R22,R25
	POP  R20
	TST  R22
	BRMI __DIVF215
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF210
__DIVF215:
	RCALL __REPACK
	POP  R21
	RET

__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

	.ORG 0

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
